#ifndef __MANEUVER_H
#define __MANEUVER_H

#include "config.h"
#include <float.h>

//! 
class ORBITDYN_API Maneuver
{
public:
	//! ʱ
	double StartTime;
	//! ػʱ
	double EndTime;
	//! ط
	Vector DV;
	//! صƽ
	double M;
	//! ȼ
	double Fuel;
	Maneuver(){
		StartTime = DBL_MAX;
		EndTime = DBL_MAX;
		Fuel = 0;
	}
	~Maneuver(){}
	//! tʱǷﵽʱ
	bool Start(double t) const{
		return t>StartTime;
	}
	//! tʱǷﵽػʱ
	bool Finish(double t) const{
		return t>EndTime;
	}
};

////! :ʱ俪ػ
//class Maneuver_Duration : public Maneuver
//{
//public:
//	Vector DV;          // ҪDV
//	double StartTime;   // ʼʱ
//	double EndTime;     // ʱ
//	Maneuver_Duration()	{
//	}
//	~Maneuver_Duration(){
//	}
//	bool Start(double t) const{
//		return t>=StartTime;
//	}
//	bool Finish(double t) const{
//		return t>=EndTime;
//	}
//};

////! :ٶػ
//class Maneuver_DV : public Maneuver
//{
//public:
//	double DV_Need;     // ҪDV
//	double DV_Now;
//	Maneuver_DV(){
//		DV_Need = 0;
//		DV_Now = 0;
//	}
//	~Maneuver_DV(){}
//	bool Finish() const{
//		return DV_Now>=DV_Need ? true : false;
//	}
//};

#endif //__MANEUVER_H
