#pragma once
#include "config.h"
#include "Constant.h"
#include "CDateTime.h"
#include "Vector.h"
#include "nrlmsise-00.h"
/*!
 \class Msise00ģͰװʽ
*/
class ORBITDYN_API CMsise00
{
public:
	struct nrlmsise_input input;
	struct nrlmsise_flags flags;
	struct nrlmsise_output output;

public:
	CMsise00(void);
	~CMsise00(void);

	//ܶ
	double Density(const CDateTime& t,const Vector& ECFr);
};

ORBITDYN_VAR CMsise00 Msise;
