/*!
㶯ٶȡѧ
ת(ϵعϵϵ)
\author  
*********************************************************************/

#include "Utility.h"
#include "Satellite.h"

/*!
ȡԱҵdataĿ¼ڵλ
*/
std::string GetOrbitDynDir()
{
#ifndef NONE_DATA_FILE_MODE
	int env;
	// ȡOrbitDyndataĿ¼λ
#if _MSC_VER < 1400
	char* Name = getenv("OrbitDyn");
	if(Name==NULL)
		env = 1;
	else
		env = 0;
#else
	char Name[100];
	size_t len;
	env = getenv_s(&len,Name,100,"OrbitDyn");
#endif // _MSC_VER < 1400
	if(!env) // 
	{
		std::string DataDir(Name);
		std::string fileName = DataDir + "\\data\\planetEph.405";
		const char *fName = fileName.c_str();
		FILE *fp;
		fopen_s(&fp,fName,"rb"); // лʱļǷ
		if(DataDir.empty() || fp == NULL)
			env = 1; // д󣬻405ļ
		else
		{
			return DataDir; // еĿ¼
		}
	}
	if(env) // ڣ򻷾
	{
		FILE* configfile;
		fopen_s(&configfile,"C:\\OrbitDyn.config","r");
		if(false/*configfile!=NULL*/)
		{  // ļ
			//configfile >> Name;
			fscanf_s(configfile,"%s",Name);
			std::string DataDir(Name);
			std::string fileName = DataDir + "\\data\\planetEph.405";
			const char *fName = fileName.c_str();
			FILE *fp;
			fopen_s(&fp,fName,"rb"); // ļǷ
			if(DataDir.empty() || fp == NULL)
			{
				if(configfile!=NULL) fclose(configfile);
				if(fp!=NULL) fclose(fp);
				return std::string("."); // ļָĿ¼ڣصǰĿ¼
			}
			else
			{
				if(configfile!=NULL) fclose(configfile);
				if(fp!=NULL) fclose(fp);
				return DataDir; // ļеĿ¼
			}
		}
		else
			return std::string("."); // ļڣصǰĿ¼
	}
	return std::string("."); // صǰĿ¼
#else
	return std::string(".");
#endif //NONE_DATA_FILE_MODE
}

/*!
\param sigma3 3
\param mean ֵ
㷨\n
   mean + sigma3 / 3.0 * ( r - 6.0 )  \n
rα0-1֮αrʾ12αĺ
*/
double WhiteNoise(double sigma3,double mean)
{
	double var=0.;
	int n;
	for(n=0;n<12;n++)
		var+=(double)rand()/RAND_MAX;
	var=(var-6.)*sigma3/3.+mean;
	return var;
}

/*! ȷֲα
\param min 
\param max 
min~max֮ȷֲαrand()min~max֮䡣
*/
double EvenNoise(double min, double max)
{
	double val;
	val=2.0*rand()/32767.0-1.0;		// -1  1 ֮ȷֲ
	val=val/2.0*(max-min);
	val=val+(min+max)/2.0;				// min  max ֮ȷֲ
	return(val);
}

/*! ʱ
˲ʱ洺ֵ㵽ξߵĽǶ
\param t  CDatetimeʱ
\return  ʱ(02)
*/
double GetSG(const CDateTime& t)
{
	double dpsi,deps;
	nutation_angle(t,dpsi,deps); // dpsi:ƾ¶
	double eps = Ecliptic_Equator_Angle(t);
	double Omega = Moon_RAAN(t);
    return fmod(GetSGM(t) + dpsi*cos(eps) + (0.00264*sin(Omega) + 0.000063*sin(2*Omega))/3600*RAD, PI2);
}

/*! ƽʱ
˲ʱƽֵ㵽ξߵĽǶ
\param t  CDatetimeʱ
\return  ƽʱ(02)
*/
double GetSGM(const CDateTime& t)
{
	// JAT-EarthRef : IERS 1997   && Orbits-Xu p.14
	double ut1 = t.GetUT1();
	double ut10 = floor(ut1);
	double T0 = (ut10 - MJD2000)/36525.0;
	double UT1 = (ut1-ut10)*86400;
	double alpha = 1.002737909350795 + (5.9006e-11 - 5.9e-12*T0)*T0;
	double GMST = 6*3600 + 41*60 + 50.54841 + 
    			  (8640184.812866 + (0.093104 - 6.2e-6*T0)*T0)*T0 + 
				  alpha*UT1;
	GMST = fmod(GMST/3600.0*15.0,360);
	return GMST*RAD;

	// ֮ǰİ汾,ļΪ4e-6(2010-1-1)ӦGEOλá3.4mLEO0.57m

	//double dt = t.GetUT1CentNum()*36525.0; // + Earth.GetdUT1(t)/86400.0; //  t.GetUT1CentNum()пdUT1
	// Ϊ㹫ʽмֵضȰѽϴתǹ㵽360ڣ볣Ͷη
	//double rota = fmod(360.985647365*dt,360);
	//return fmod((280.4606184 + rota + 0.2908e-12*dt*dt)*RAD,PI2);
}

/*! J2000.0κʱ
J2000.0ƽֵ㵽ξߵĽǶ
\param t  CDatetimeʱ
\return  J2000.0κʱ(02)
*/
double GetSGJ2000(const CDateTime& t)
{
	double zeta,theta,Z;
	precession_angle(t,zeta,theta,Z);
    return fmod(GetSGM(t) - zeta - Z,PI2);
}

/*! ̫ƽƫ
\param t CDatetimeʱ
\return ̫ƽƫ
*/
double Sun_Eccentricity(const CDateTime& t)
{
	double T = t.GetTDTCentNum();
	return 0.01670862 - 4.204e-5*T - 1.24e-6*T*T;
}

/*! ƵJ2000.0ƽĻƳཻǦ
\param t CDatetimeʱ
\return Ƴཻ()
*/
double Ecliptic_Equator_Angle(const CDateTime& t)
{
	double T = t.GetTDTCentNum();
	return (23.4392911 - 0.013004167*T - 1.64e-7*T*T ) * RAD;	
}

/*! J2000.0̫ƽص
\param t CDatetimeʱ
\return ̫صƽƾ()
*/
double Sun_Argument_Perigee(const CDateTime& t)
{
	double T = t.GetTDTCentNum();
	return fmod((282.9373472 + 0.32256206*T + 1.51e-4*T*T )*RAD,PI2);
	//(282.9373472 + 6190.32/3600.0*T + 1.655/3600.0*T*T)ΪԵƽֵ
	// Ľȥƾõʹõʽ
}

/*! J2000.0̫ƽM
\param t CDatetimeʱ
\return ̫ƽ()
*/
double Sun_Mean_Anomaly(const CDateTime& t)
{
	double T = t.GetTDTCentNum();
	//return fmod((357.5291 + 35997.65235681*T - 0.0001561*T*T)*RAD,PI2);
	return fmod((357.5291 + 129596581.04/3600.0*T - 0.562/3600.0*T*T)*RAD,PI2);
}

/*! ڵƽֵ̫ƽƾL
\param t CDatetimeʱ
\return ̫ƽƾ()
*/
double Sun_Ecliptic_Longitude(const CDateTime& t)
{
	double T = t.GetTDTCentNum();
	return ( 280.46644722 + 36000.7698222222*T + 1.093/3600.0*T*T ) * RAD;
}

/*! ڵƽֵİ׵صƽƾ
\param t CDatetimeʱ
\return ׵صƽƾ()
*/
double Moon_Argument_Perigee(const CDateTime& t)
{
	double T = t.GetTDTCentNum();
	return fmod(( 83.3532417 + 4069.013711*T - 37.165/3600.0*T*T ) * RAD,PI2);
}

/*! ڵƽֵİ׵ƽƾ
\param t CDatetimeʱ
\return ׵ƽƾ()
*/
double Moon_RAAN(const CDateTime& t)
{
	double T = t.GetTDTCentNum();
	return ( 125.0445555 - 1934.136185*T + 7.476/3600.0*T*T ) * RAD;
}

/*! ڵƽֵƽƾL
\param t CDatetimeʱ
\return ƽƾ()
*/
double Moon_Ecliptic_Longitude(const CDateTime& t)
{
	double T = t.GetTDTCentNum();
	return ( 218.31665555 + 481267.8813425*T - 4.787/3600.0*T*T ) * RAD;
}

/*! ڵƽֵƽM
\param t CDatetimeʱ
\return ƽ()
*/
double Moon_Mean_Anomaly(const CDateTime& t)
{
	return fmod(Moon_Ecliptic_Longitude(t) - Moon_Argument_Perigee(t),PI2);
}

/*! ڵƽֵ̫ƽD
\param t CDatetimeʱ
\return ̫ƽ()
*/
double Moon_Sun_Ecliptic_Angle(const CDateTime& t)
{
	return Moon_Mean_Anomaly(t) - Sun_Mean_Anomaly(t);
}

/*!RKF78
\param s 
\param h 
\return ض
*/
double RKF78(const CSatelliteBase& s,double h,double* x,double* xh,const int dim)
{
	static const double ak[13] = {
		            0,		2.0 / 27.0,		1.0 / 9.0,		1.0 / 6.0,		5.0 / 12.0,		1.0 / 2.0,
			5.0 / 6.0,		1.0 / 6.0,		2.0 / 3.0,		1.0 / 3.0,		1.0,		0.0,		1.0  };

	static const double b1 = 2.0 / 27.0;
	static const double b2[2] = { 1.0/36.0, 1.0/12.0 };
	static const double b3[3] = { 1.0/24.0, 0.0, 0.125 };
	static const double b4[4] = { 5.0/12.0, 0.0, -1.5625, 1.5625 };
	static const double b5[5] = { 0.05,	0.0, 0.0, 0.25, 0.2 };
	static const double b6[6] = { -25.0/108.0, 0.0, 0.0, 125.0/108.0, -65.0/27.0, 125.0/54.0 };
	static const double b7[7] = {  31.0/300.0, 0.0, 0.0, 0.0, 61.0/225.0, -2.0/9.0, 13.0/900.0 };
	static const double b8[8] = { 2.0, 0.0, 0.0, -53.0/6.0, 704.0/45.0, -107.0/9.0, 67.0/90.0, 3.0 };
	static const double b9[9] = { -91.0/108.0, 0.0, 0.0, 23.0/108.0, -976.0/135.0, 311.0/54.0, -19.0/60.0, 17.0/6.0, -1.0/12.0 };
	static const double b10[10] = { 2383.0/4100.0, 0.0, 0.0, -341.0/164.0, 4496.0/1025.0, -301.0/82.0, 2133.0/4100.0, 45.0/82.0, 45.0/164.0, 18.0/41.0 };
	static const double b11[11] = { 3.0/205.0, 0.0, 0.0, 0.0, 0.0, -6.0/41.0, -3.0/205.0, -3.0/41.0, 3.0/41.0, 6.0/41.0, 0.0 };
	static const double b12[12] = { -1777.0/4100.0, 0.0, 0.0, -341.0/164.0, 4496.0/1025.0, -289.0/82.0, 2193.0/4100.0, 51.0/82.0, 33.0/164.0, 12.0/41.0, 0.0, 1.0 };
	static const double W[13] = { 0.0, 0.0, 0.0, 0.0, 0.0, 34.0/105.0, 9.0/35.0, 9.0/35.0, 9.0/280.0, 9.0/280.0, 0.0, 41.0/840.0, 41.0/840.0 };

	int ii;
	double t1;
	static double x1[7];
	static double y[13][7];

	double t = s.t();
	for(ii=0;ii<dim;ii++) x1[ii] = x[ii];
	t1 = t;
	s.DynFunction(t1,x1,y[0],dim);

	for(ii=0;ii<dim;ii++) x1[ii] = x[ii] + h*b1*y[0][ii];
	t1 = t + h*ak[1];
	s.DynFunction(t1,x1,y[1],dim);

	for(ii=0;ii<dim;ii++) x1[ii] = x[ii] + h*(b2[0]*y[0][ii] + b2[1]*y[1][ii]);
	t1 = t + h*ak[2];
	s.DynFunction(t1,x1,y[2],dim);

	for(ii=0;ii<dim;ii++) x1[ii] = x[ii] + h*(b3[0]*y[0][ii] + b3[2]*y[2][ii]);
	t1 = t + h*ak[3];
	s.DynFunction(t1,x1,y[3],dim);

	for(ii=0;ii<dim;ii++) x1[ii] = x[ii] + h*(b4[0]*y[0][ii] + b4[2]*y[2][ii] + b4[3]*y[3][ii]);
	t1 = t + h*ak[4];
	s.DynFunction(t1,x1,y[4],dim);

	for(ii=0;ii<dim;ii++) x1[ii] = x[ii] + h*(b5[0]*y[0][ii] + b5[3]*y[3][ii] + b5[4]*y[4][ii]);
	t1 = t + h*ak[5];
	s.DynFunction(t1,x1,y[5],dim);

	for(ii=0;ii<dim;ii++) x1[ii] = x[ii] + h*(b6[0]*y[0][ii] + b6[3]*y[3][ii] + b6[4]*y[4][ii] + b6[5]*y[5][ii]);
	t1 = t + h*ak[6];
	s.DynFunction(t1,x1,y[6],dim);

	for(ii=0;ii<dim;ii++) x1[ii] = x[ii] + h*(b7[0]*y[0][ii] + b7[4]*y[4][ii] + b7[5]*y[5][ii] + b7[6]*y[6][ii]);
	t1 = t + h*ak[7];
	s.DynFunction(t1,x1,y[7],dim);

	for(ii=0;ii<dim;ii++) x1[ii] = x[ii] + h*(b8[0]*y[0][ii] + b8[3]*y[3][ii] + b8[4]*y[4][ii] + b8[5]*y[5][ii] + b8[6]*y[6][ii] + b8[7]*y[7][ii]);
	t1 = t + h*ak[8];
	s.DynFunction(t1,x1,y[8],dim);

	for(ii=0;ii<dim;ii++) x1[ii] = x[ii] + h*(b9[0]*y[0][ii] + b9[3]*y[3][ii] + b9[4]*y[4][ii] + b9[5]*y[5][ii] + b9[6]*y[6][ii] + b9[7]*y[7][ii] + b9[8]*y[8][ii]);
	t1 = t + h*ak[9];
	s.DynFunction(t1,x1,y[9],dim);

	for(ii=0;ii<dim;ii++) x1[ii] = x[ii] + h*(b10[0]*y[0][ii] + b10[3]*y[3][ii] + b10[4]*y[4][ii] + b10[5]*y[5][ii] + b10[6]*y[6][ii] + b10[7]*y[7][ii] + b10[8]*y[8][ii] + b10[9]*y[9][ii]);
	t1 = t + h;  // ak[10] = 1.0
	s.DynFunction(t1,x1,y[10],dim);

	for(ii=0;ii<dim;ii++) x1[ii] = x[ii] + h*(b11[0]*y[0][ii] + b11[5]*y[5][ii] + b11[6]*y[6][ii] + b11[7]*y[7][ii] + b11[8]*y[8][ii] + b11[9]*y[9][ii]);
	t1 = t;     // ak[11] = 0.0
	s.DynFunction(t1,x1,y[11],dim);

	for(ii=0;ii<dim;ii++) x1[ii] = x[ii] + h*(b12[0]*y[0][ii] + b12[3]*y[3][ii] + b12[4]*y[4][ii] + b12[5]*y[5][ii] + b12[6]*y[6][ii] + b12[7]*y[7][ii] + b12[8]*y[8][ii] + b12[9]*y[9][ii] + b12[11]*y[11][ii]);
	t1 = t + h;   // ak[12] = 1.0
	s.DynFunction(t1,x1,y[12],dim);

	double EE = 0.0;
	for(ii=0;ii<dim;ii++)
	{
		xh[ii] = x[ii] + h*( W[5]*y[5][ii] + W[6]*y[6][ii] + W[7]*y[7][ii] + W[8]*y[8][ii] + W[9]*y[9][ii] + W[11]*y[11][ii] + W[12]*y[12][ii] );
		EE = EE + fabs((y[0][ii] + y[10][ii] - y[11][ii] - y[12][ii])*h*41.0/840.0); // ضۼƺ
	}

	return EE;
}

/*!Gill4
\param s 
\param h 
\return ض
*/
double Gill4(const CSatelliteBase& s,double h,double* x,double* xh,const int dim)
{
	static const double s2 = sqrt(2.0);
	double x1[7];
	double y[4][7];
	
	int ii;
	double t = s.t(); // CRapidSatllite,ѧвt
	for(ii=0;ii<dim;ii++) x1[ii] = x[ii];
	s.DynFunction(t,x1,y[0],dim);

	for(ii=0;ii<dim;ii++) x1[ii] = x[ii] + h/2*y[0][ii];
	s.DynFunction(t,x1,y[1],dim);

	for(ii=0;ii<dim;ii++) x1[ii] = x[ii] + h*((s2-1)/2*y[0][ii] + (1-s2/2)*y[1][ii]);
	s.DynFunction(t,x1,y[2],dim);

	for(ii=0;ii<dim;ii++) x1[ii] = x[ii] + h*(-s2/2*y[1][ii] + (1+s2/2)*y[2][ii]);
	s.DynFunction(t,x1,y[3],dim);

	for(ii=0;ii<dim;ii++)
		xh[ii] = x[ii] + h/6*(y[0][ii] + (2-s2)*y[1][ii] + (2+s2)*y[2][ii] + y[3][ii]);

	return 0;
}

/*!г㶯Zonal Harmonic Terms
\param LL г
\param SatPos ڵعϵе
\param cb 壬ĬEarthг㶯ΪMoonʱг㶯
\return г㶯ٶ(ECF)(km/s^2)
гƺΪ
\[
V_l  = \frac{\mu }{r}\sum\limits_{l = 2}^\infty  {\overline C _l } \left( {\frac{{{\mathop{\rm Re}\nolimits} }}{r}} \right)^l \overline P _l \left( {\sin \phi } \right)
\]
г㶯ٶΪ
\[
\frac{{\partial V_l }}{{\partial {\bf{r}}}} = \frac{{\partial V_l }}{{\partial r}} \cdot \frac{{\partial r}}{{\partial {\bf{r}}}} + \frac{{\partial V_l }}{{\partial \sin \phi }} \cdot \frac{{\partial \sin \phi }}{{\partial {\bf{r}}}} + \frac{{\partial V_l }}{{\partial \lambda }} \cdot \frac{{\partial \lambda }}{{\partial {\bf{r}}}}
\]
У
\[
\frac{{\partial V_l }}{{\partial \lambda }} =  - \frac{\mu }{{r^2 }}\sum\limits_{l = 2}^\infty  {\overline C _l \left( {l + 1} \right)} \left( {\frac{{{\mathop{\rm Re}\nolimits} }}{r}} \right)^l \overline P _l \left( {\sin \phi } \right)
\]
\[
\frac{{\partial V_l }}{{\partial \sin \phi }} = \frac{\mu }{r}\sum\limits_{l = 2}^\infty  {\overline C _l } \left( {\frac{{{\mathop{\rm Re}\nolimits} }}{r}} \right)^l \overline {P'} _l \left( {\sin \phi } \right)
\]
\[
\frac{{\partial V_l }}{{\partial \lambda }} = 0
\]
\[
\frac{{\partial r}}{{\partial {\bf{r}}}} = \frac{{\bf{r}}}{r} = \frac{1}{r}\left( \begin{array}{l}
 x \\ 
 y \\ 
 z \\ 
 \end{array} \right)
\]
\[
\frac{{\partial \sin \phi }}{{\partial {\bf{r}}}} =  - \frac{z}{{r^3 }}{\bf{r}} + \frac{1}{r}{\bf{k}} =  - \frac{z}{{r^3 }}\left( \begin{array}{l}
 x \\ 
 y \\ 
 z \\ 
 \end{array} \right) + \frac{1}{r}\left( \begin{array}{l}
 0 \\ 
 0 \\ 
 1 \\ 
 \end{array} \right)
\]
\[
\frac{{\partial \lambda }}{{\partial {\bf{r}}}} = \frac{1}{{x^2  + y^2 }}\left( \begin{array}{l}
  - y \\ 
 x \\ 
 0 \\ 
 \end{array} \right) = \frac{1}{{x^2  + y^2 }}\left( \begin{array}{l}
  - \sin \lambda  \\ 
 \cos \lambda  \\ 
 0 \\ 
 \end{array} \right)
\]
*/
const Vector PZonalHarmonic(const int LL,const Vector& SatPos,const CentralBody* cb )/* cb = Earth */
{
	static Vector k(0,0,1);
	static double PL[71];
	if(cb==NULL)
		cb = Earth::Instance();
	double r = SatPos.Module();
	double zr = SatPos.z/r;
	if(LL<2) return Vector(0,0,0);//ǵ㶯
	Legendre_sphPl(LL,zr,PL);
	Vector prpr = SatPos/r;
	Vector psfpr = -zr/r/r*SatPos + 1.0/r*k;

	double WP,RL,dPL,pVpr=0,pVpsf=0;
	for(int L=2;L<=LL;L++)
	{
		WP = sqrt((2.0*L+1.0)/(2.0*L-1.0));
		if(zr*zr==1.0)
			dPL = 0;
		else
            dPL = L/(1.0-zr*zr)*(WP*PL[L-1]-zr*PL[L]);
		RL = pow(cb->RE()/r,L);
		pVpr += cb->CLM[L][0]*RL*(L+1.0)*PL[L];
		pVpsf += cb->CLM[L][0]*RL*dPL;
	}
	pVpr *= -cb->GE()/r/r;
	pVpsf *= cb->GE()/r;
	return pVpr*prpr + pVpsf*psfpr;
}

/*! Tesseral Harmonic Terms
\param LL 
\param SatPos عϵе
\param cb 壬ĬEarthг㶯,ΪMoonʱг㶯
\return Tesseral Harmonic Acceleration(ECF)(km/s^2)
*/
const Vector PTesseralHarmonic(const int LL,const Vector& SatPos,const CentralBody* cb )/* cb = Earth */
{
	static Vector k(0,0,1);
	static double PLM[71][71]={0},SX[71]={0},CX[71]={0};
	if(cb==NULL)
		cb = Earth::Instance();
	double RL,dPlm,WCS,WSC,pVpr=0,pVpsf=0,pVpl=0;
	double r = SatPos.Module();
	double zr = SatPos.z/r;
	Legendre_sphPlm(LL,zr,PLM);
	double gxy = sqrt(SatPos.x*SatPos.x+SatPos.y*SatPos.y);
	if(fabs(gxy)<1.0e-6)
	{
		Vector F;
		for(int L=2;L<=LL;L++)
		{
			RL = pow(cb->RE()/r,L);
			F.x -= cb->CLM[L][1]*PLM[L][1]/RL;
			F.y -= cb->SLM[L][1]*PLM[L][1]/RL;
		}
		return -cb->GE()/r/r*F;
	}
	Vector prpr = SatPos/r;
	Vector psfpr = -zr/r/r*SatPos + 1.0/r*k;
	Vector plpr(-SatPos.y,SatPos.x,0.0);
	plpr = plpr/(gxy*gxy);
	SmxCmx(LL, SatPos.y/gxy, SatPos.x/gxy, SX, CX);
	for(int L=2;L<=LL;L++)
	{
		RL = pow(cb->RE()/r,L);
		for(int M=1;M<=L;M++)
		{
			dPlm = 1.0/(1.0-zr*zr)*(sqrt((2.0*L+1)/(2.0*L-1)*(L+M)*(L-M))*PLM[L-1][M]-L*zr*PLM[L][M]);
            WCS = cb->CLM[L][M]*CX[M] + cb->SLM[L][M]*SX[M];
			WSC = cb->SLM[L][M]*CX[M] - cb->CLM[L][M]*SX[M];
			pVpr -= RL*(L+1.0)*PLM[L][M]*WCS;
			pVpsf += RL*dPlm*WCS;
			pVpl += RL*M*PLM[L][M]*WSC;
		}
	}
	pVpr *= cb->GE()/r/r;
	pVpsf *= cb->GE()/r;
	pVpl *= cb->GE()/r;
	return pVpr*prpr + pVpsf*psfpr + pVpl*plpr;
}

/*! Pl(x):Normalized legendre Polynomial
\param LL 
\param x Ա
\param PL һõ¶ʽֵ
*/
void Legendre_sphPl(const int LL,const double x,double PL[])
{
	double W1,W2,W3,W4;
	PL[0] = 1;
	PL[1] = sqrt(3.0) * x;
	PL[2] = sqrt(5.0) * (1.5*x*x-0.5);
	if(LL<3) return;
	for(int L=3;L<=LL;L++)
	{
		W1 = 1.0/L;
		W2 = 2.0*L;
		W3 = sqrt((W2-1.0)/(W2-3.0)); // sqrt(2l-1)/(2L-3)
		W4 = sqrt((W2+1.0)/(W2-1.0)); // sqrt(2l+1)/(2L-1)
		PL[L] = W4*( (2.0-W1)*x*PL[L-1]-W3*(1.0-W1)*PL[L-2] );
	}
}
/*! Plm(x):Normalized legendre Polynomial
\param LL 
\param x Ա
\param PLM һõ¶ʽֵ
*/
void Legendre_sphPlm(const int LL,const double x,double PLM[][71])
{
	double G3 = sqrt(3.0);
	double GX2 = sqrt(1-x*x);
	double W1,W2,WL1,WL2,WL3,WL0,WM1,WM2,WM3,WM12,WLM1,WLM2;
	PLM[1][1] = G3*GX2;
	for(int L=2;L<=LL;L++)
	{
		W1 = 2.0*L;         // 2L
		W2 = sqrt(W1);      // sqrt(2L)
		WL1 = sqrt(W1+1.0); // sqrt(2L+1)
		WL2 = sqrt(W1-1.0); // sqrt(2L-1)
		WL3 = sqrt(W1-3.0); // sqrt(2L-3)
		WL0 = WL1/W2;       // sqrt(2L+1)/2L
		PLM[L][L] = WL0 * GX2 * PLM[L-1][L-1];
		PLM[L][L-1] = WL1 * x * PLM[L-1][L-1];
		for(int M=1;M<=L-2;M++)
		{
			WM1 = L + M;       // L+M
			WM2 = L - M;       // L-M
			WM3 = sqrt((WM1-1.0)*(WM2-1.0)); // sqrt(L+M-1)*(L-M-1)
			WM12 = sqrt(WM1*WM2);    // sqrt(L+M)*(L-M)
			WLM1 = WL1*WL2/WM12;     // sqrt(2L+1)*(2L-1)/(L+M)/(L-M)
			WLM2 = WM3*WL1/(WM12*WL3); // sqrt(2L+1)*(L+M-1)*(L-M-1)/(2L-3)/(L+M)/(L-M)
			PLM[L][M] = WLM1 * x * PLM[L-1][M] - WLM2 * PLM[L-2][M];
		}
	}
}
/*! õƷsin(m*x)cos(m*x)
\param LL 
\param S1X  sin(x)
\param C1X  cos(x)
\param SX  sin(m*x)
\param CX  cos(m*x)
*/
void SmxCmx(const int LL,const double S1X,const double C1X,double* SX,double* CX)
{
	SX[0] = 0;    // sin(0)
	CX[0] = 1;    // cos(0)
	SX[1] = S1X;  // sin(x)
	CX[1] = C1X;  // cos(x)
	SX[2] = 2.0*SX[1]*CX[1]; // 2sin(x)cos(x)
	CX[2] = 2.0*CX[1]*CX[1] - 1.0; // 2cos(x)^2 -1
	if(LL<3) return;
	double CX2 = 2.0 * CX[1]; // 2cos(x)
	for(int MM=3;MM<=LL;MM++)
	{
		SX[MM] = CX2*SX[MM-1] - SX[MM-2]; // 2cos(x)sin[(m-1)x] - sin[(m-2)x]
		CX[MM] = CX2*CX[MM-1] - CX[MM-2]; // 2cos(x)cos[(m-1)x] - cos[(m-2)x]
	}
}
/*! third body gravitation
\note r,r3b,GĵλҪͳһϵҪͳһ
\param r satellite vector
\param r3b third body vector
\return third body Gravity Acceleration(ECI)(km/s^2)
*/
const Vector PThirdBodyGrv(const Vector& r, const Vector& r3b,double G)
{
	Vector dr = r - r3b;
	double r3b3 = pow(r3b.Module(),3);
	double dr3 = pow(dr.Module(),3);
	return - G * (dr/dr3 + r3b/r3b3);
}
/*!Ӱ--˫Բ׶Ӱģdual cone
ǷڰӰ(penumbra)Ӱ(umbra)
ؿ(visible fraction),ӶΪӰΪ0,Ӱ0~1֮,Ϊ1
úʱעrrsΪ嵽ǡ̫ʸ
\param r λʸ
\param rs ̫λʸ
\param Rcb 뾶(ĬΪ뾶)
\return (visible fraction)
*/
double Shadow(const Vector& r,const Vector& rs,const double& Rcb )/* Rcb = Re */
{
	Vector dr = r - rs;
	double rm = r.Module(), drm = dr.Module();
	double thetaES = acos( Dot(r,dr)/rm/drm );  // --̫н
	double as = asin(Rs/drm);  // Ͽ̫Ӱ뾶
	double ae = asin(Rcb/rm);  // ϿӰ뾶
	if( thetaES <= ae-as)
	{
		return 0.0; // Ӱȫʳ
	}
	else if( thetaES < ae+as )
	{
		if(as-thetaES>=ae)
			return 1.0-ae*ae/as/as;  // ̫Ӱ뾶Сջʳ
		else
		{
			double a = acos( (ae*ae+thetaES*thetaES-as*as)/(2.0*ae*thetaES) );
			double b = acos( (as*as+thetaES*thetaES-ae*ae)/(2.0*as*thetaES) );
			return 1.0 - ( as*as*(b-sin(b)*cos(b)) + ae*ae*(a-sin(a)*cos(a)) )/as/as/PI;  // ̫̫Բıֵƫʳ
		}			
	}
	else
	{
		return 1.0; // 
	}
}

/*!Ӱ--ԲӰģ
ǷڰӰ(penumbra)Ӱ(umbra)
ؿ(visible fraction),ӶΪӰΪ0,Ӱ0~1֮,Ϊ1
úʱעrrsΪ嵽ǡ̫ʸ
\param r λʸ
\param rs ̫λʸ
\param Radius 뾶(ĬΪ뾶)
\return (visible fraction)
*/
double Shadow_Cylindrical(const Vector& r,const Vector& rs,double Radius)
{
	double r1  = r.Module();
	double rs1 = rs.Module();
 	double CPS = Dot(r,rs)/(r1*rs1);
	double SPS = sqrt(1-CPS*CPS);
	if(CPS<0 && SPS<Radius/r1) return 0.0;  //жϵӰ
	return 1.0;
}
/*! ѹ㶯 Light Pressure
\param CrSM  Cr*Area/Mass  Cr:ϵ  Area:ѹ    Mass:
\param r λʸ
\param rs ̫λʸ
\return ѹ㶯ٶ(km/s^2)
*/
const Vector PLightPressure(const double CrSM,const Vector& r,const Vector& rs,double Radius )/* Radius = Re */
{
	Vector dr = r - rs;
	double dr1 = dr.Module();
	Vector acc = Shadow(r,rs,Radius) * 4.5604e-6 * CrSM * pow(AU/dr1,2)/dr1 * dr;  // 4.5604e-6һAU̫ѹ(N/m^2)

	// STK HPOPʹõĹʽĹʽЧ3.823e26Ϊ̫书[W]4.5604e-6 = 3.823e26/(4*PI*c*AU^2)
	//Vector acc = CrSM * 3.823e26 / (4*PI*LightVel*pow(dr,3)); 

	return acc/1000.0; // صĹѹ㶯ٶΪkm/s^2
}
/*! 㶯 Atmosphere Drag
\param CdSM Cd*Area/Massϵʱ(m^2/kg)
\param ruo ܶ(kg/m^3)
\param r λʸ
\param rd ٶʸ
\return ٶ(ECI)(km/s^2)
*/
const Vector PAirDrag(const CDateTime& t,const double CdSM,const Vector& ECFr,const Vector& r,const Vector& rd)
{
	Vector air(-We*r.y, We*r.x, 0); // תǣٶ = (0,0,We)r
	Vector RelVel = rd - air;
	double ruo = Earth::Instance()->AtmosRuoH(t,ECFr);
	return ( -0.5* CdSM*1.0e-6 * ruo*1.0e9 * RelVel.Module() )*RelVel;
}
/*! ţЧӦ㶯 Post-Newtonian Effect
\param r λʸ
\param rd ٶʸ
\return ţЧӦ㶯ٶ(ECI)(km/s^2)
*/
const Vector PPostNewton(const Vector& r,const Vector& rd)
{
	double c2 = LightVel*LightVel;
	double r1 = r.Module();
	double r3 = r1*r1*r1;
	double c2r3 = c2*r3;
	double v2 = rd.Module();
    double r4v2 = 4.0 * GE / r1 - v2 * v2;
	double rv4 = 4.0 * Dot(r,rd);
	return (r*r4v2 + rd*rv4) * GE / c2r3;
}

/*! λٶȼ
\param miu 
\param Position λ
\param Velocity ٶ
\return (km, ,rad,rad,rad,rad)
*/
Kepler Cartesian_Kepler(const Vector & Position,const Vector & Velocity, double miu )/* miu = GE */
{
	 double a,e,i,o,w,M,u,EE;
	 double r = Position.Module();
	 double v = Velocity.Module();
	 if(r==0 || v==0)
		 throw TVectorException("Cartesian_Kepler(): position or velocity is zero.");
	 double v2 = v*v;
	 //double rrd = Dot(Position,Velocity);
/*a*/a = 1.0/(2.0/r-v2/miu);
	 Vector Uz(0.0,0.0,1.0); // ECI-Z
	 Vector h = Cross(Position,Velocity);//Ƕ
	 Vector N = Cross(Uz,h);//߷
	 double p = Dot(h,h)/miu;
/*e*/if( p/a >= 1.0 ) e = 0;
	 else e = sqrt(1.0-p/a);

	 double cosi = Dot(h,Uz)/h.Module();
/*i*/if(cosi>=1.0) i = 0.0;
	 else if(cosi<=-1.0) i = PI;
	 else i = acos(cosi);

	 double Nx = N.x/N.Module();
/*o*/if(Nx>=1.0) o = 0.0;
	 else if(Nx<=-1.0) o = PI;
	 else o = N.y>0 ? acos(Nx) : PI2-acos(Nx) ;

	 Vector E = Cross(Velocity,h)/miu - Position/r; //((v2-1.0/r)*Position-rrd*Velocity);
	// Vector Eh = (v2/miu-1/r)*Position - rrd/miu*Velocity; ʽͬ
/*w*/if(E.Module()==0)
	{
		w = 0;
	}
	else
	{
		 double cosw = Dot(N,E)/N.Module()/E.Module();
		 if(cosw>=1.0) w = 0.0;
		 else if(cosw<=-1.0) w = PI;
		 else w = E.z>0 ? acos(cosw) : PI2-acos(cosw) ;
	}

	 double cosu = Dot(Position,N)/r/N.Module();
	 if(cosu>=1.0) u = 0.0;
	 else if(cosu<=-1.0) u = PI;
	 else u = Position.z>0 ? acos(cosu) : PI2-acos(cosu);
	 if(e<=1.0)
	 {
		 EE = fmod(atan2(r*sin(u-w)/a/sqrt(1-e*e),r/a*cos(u-w)+e)+PI2,PI2);
/*M*/    M = mod(EE - e*sin(EE),PI2);
	 }
	 else
	 {
		 double tmp = (r*sin(u-w)/a/sqrt(e*e-1)) / (r/a*cos(u-w)+e);
		 EE = 0.5*log((1+tmp)/(1-tmp));
/*M*/    M = fmod(EE - e*sinh(EE),PI2);
		 M = mod(M,PI2);
	 }
	 return Kepler(a,e,i,o,w,M);
}
/*! ɹλٶ
\param obl 
\param Pos λ
\param Vel ٶ
\param miu 
*/
void Kepler_Cartesian(const Kepler& obl,Vector& Pos,Vector& Vel, double miu )/* miu = GE */
{
	double sino = sin(obl.o);
	double coso = cos(obl.o);
	double sinw = sin(obl.w);
	double cosw = cos(obl.w);
	double sini = sin(obl.i);
	double cosi = cos(obl.i);
	Vector P(coso*cosw-sino*sinw*cosi,
		sino*cosw+coso*sinw*cosi,
		sinw*sini);
	Vector Q(-coso*sinw-sino*cosw*cosi,
		-sino*sinw+coso*cosw*cosi,
		cosw*sini);
	double r = obl.r();
	double f = obl.f();
	Pos = r*cos(f)*P + r*sin(f)*Q;
	Vel = -sqrt(miu/obl.p())*( sin(f)*P - (cos(f)+obl.e)*Q );
}
/*! ˲ʱ
\param MeanElem ƽ{a e i O w M}
\return ˲ʱ
*/
Kepler Instant(const Kepler & MeanElem)
{
	double ShortTerm[6],as2;//ShortTerm[6]:,as2:볤Ķ׶
	Short2(MeanElem,ShortTerm,as2);
	Kepler InstElem;
	InstElem.a = MeanElem.a + ShortTerm[0] + as2;
	InstElem.i = MeanElem.i + ShortTerm[1];
	InstElem.o = MeanElem.o + ShortTerm[2];
	double ksi = MeanElem.e*cos(MeanElem.w) + ShortTerm[3];
	double eta = MeanElem.e*sin(MeanElem.w) + ShortTerm[4];
	double lamda = MeanElem.w + MeanElem.M + ShortTerm[5];
	InstElem.e = sqrt(ksi*ksi + eta*eta);
	InstElem.w = fmod(atan2(eta,ksi) + PI2,PI2);
	InstElem.M = fmod(lamda - InstElem.w + 2*PI2,PI2);
	return InstElem;
}
/*! 
\param MElem ƽ
\param ZS (a_s,i_s,Omega_s,ksi_s,eta_s,lamda_s)
\param AS2 aĶ׳
*/
void Short2(const Kepler & MElem,double ZS[6],double & AS2)
{
	double A2 = Earth::Instance()->A2; // ʹConstant::A2
	double M_a = MElem.a / Re;
	double M_i = MElem.i;
	//double M_omiga = MElem.o;
	double M_ksi = MElem.e*cos(MElem.w);
	double M_eta = MElem.e*sin(MElem.w);
	double M_lamda = fmod(MElem.w + MElem.M + PI2,PI2);

	double E2 = M_ksi*M_ksi + M_eta*M_eta;  // e^2
	double WE2 = 1.0 - E2;                  // 1 - e^2
	double GE2 = sqrt(WE2);                 // sqrt(1-e^2)
	double F1e = 1.0 / (1.0 + GE2);         // F1e = 1/( 1+sqrt(1-e^2) )
// ⲿּuۡP174°ҳ
// ﶨ ksi = e*cos(w) , eta = e*sin(w) ϲţӦĹʽӸ
	double UE = KeplerFunc2(M_ksi,M_eta,M_lamda); // E + w
	double SU = sin(UE);                         // sin(E+w)
	double CU = cos(UE);                         // cos(E+w)
	double Ef = M_ksi*SU - M_eta*CU;             // UE-lamda = E - M
	double RA = 1.0/(1.0 - M_ksi*CU - M_eta*SU); // a/r
	double RA3 = RA * RA * RA;                   // (a/r)^3
	// Uļֽ֣ȷ,ַf=90270ʱڽض
	// 1.֡ۡϵĹʽ
	double SfE = RA*Ef*( 1.0 + F1e*(-M_eta*SU - M_ksi*CU) );  // sin(u-UE)
	double W = SfE / sqrt( 1.0 - SfE*SfE );      // tan(u-UE)
	double fE = atan(W);                         // u-UE
	double UJMw = fE + Ef;                       // u-lmada = (u-UE) + (UE-lamda)
	double U = M_lamda + UJMw;                   // u
	double S1u = sin(U);           // sin(u)
	double C1u = cos(U);           // cos(u)
	// 2.ȷϵĹʽ
	//double S1u = RA*(M_ksi*(M_lamda-UE)*F1e + SU - M_eta);
	//double C1u = RA*(-M_eta*(M_lamda-UE)*F1e + CU - M_ksi);
	//double U = atan2(S1u,C1u);
	//double UJMw = U - M_lamda; // u-lamda
/////////////////////////////////////////////////////
	double S2u = 2.0 * S1u * C1u;  // sin(2u)
	double C2u = 2.0*C1u*C1u-1.0;  // cos(2u)
	double SI = sin(M_i);          // sin(i)
	double S2 = SI * SI;           // sin(i)^2
	ZS[0] = A2/M_a * ( (2.0/3.0-S2) * (RA3-pow(WE2,-1.5)) + S2*RA3*C2u );   // aĶas
//--ZS[0] END----------------------------------------------------
	double P = M_a * WE2;   // p = a(1-e^2)
	double P2 = P * P;      // p^2
	double A2P2 = A2/P2;    // A2/p^2
	double F2e = (1.0+2.0*GE2)*F1e*F1e;     // F2(e)
	double F3e = 0.25*(1.0+3.0*GE2)*F1e*F1e*F1e; // F3(e)
	double S3u = S1u*C2u + C1u*S2u;  // sin(3u)
	double C3u = C1u*C2u - S1u*S2u;  // cos(3u)
	double S4u = S1u*C3u + C1u*S3u;  // sin(4u)
	double C4u = C1u*C3u - S1u*S3u;  // cos(4u)
	double S5u = S1u*C4u + C1u*S4u;  // sin(5u)
	double C5u = C1u*C4u - S1u*S4u;  // cos(5u)
	double CI = cos(M_i);           // cos(i)
	double W23i = 1.0 - 1.5*S2;     // 1-3/2*sin(i)^2
	double W25i = 2.0 - 2.5*S2;     // 2-5/2*sin(i)^2
	double Wkc1 = M_ksi * M_ksi;    // ksi^2
	double Wkc2 = M_eta * M_eta;    // eta^2
	double Wkc3 = Wkc1 - Wkc2;      // ksi^2 - eta^2
	double Wkc4 = M_ksi * M_eta;    // ksi*eta

	ZS[1] = 0.5*A2P2*SI*CI*(M_ksi*C1u-M_eta*S1u+C2u+(M_ksi*C3u+M_eta*S3u)/3.0+Wkc3*F2e/3.0);

	ZS[2] = -A2/P2*CI*(UJMw+0.5*(M_ksi*S1u-3.0*M_eta*C1u)-0.5*S2u-(M_ksi*S3u-M_eta*C3u)/6.0-Wkc4*F2e/3.0);

	ZS[3] = A2P2*(-W25i*UJMw*M_eta+((1.0+0.25*Wkc1+2.25*Wkc2)*C1u-Wkc4*S1u
			+0.5*M_ksi*C2u+M_eta*S2u+(Wkc1-3.0*Wkc2)*C3u/12.0+Wkc4*S3u/3.0+(1.0-E2*F2e/12.0)*M_ksi
			-(Wkc1-3.0*Wkc2)*M_ksi*F2e/12.0)+S2*((-1.25+0.375*Wkc1-3.125*Wkc2)*C1u+0.25*Wkc4*S1u
	        +0.5*M_ksi*C2u-2.0*M_eta*S2u+(7.0/12.0+11.0/48.0*Wkc1+25.0/48.0*Wkc2)*C3u
	        -7.0/24.0*Wkc4*S3u+0.375*(M_ksi*C4u+M_eta*S4u)+Wkc3*C5u/16.0+Wkc4*S5u/8.0-(1.25-E2*F2e/6.0)*M_ksi
			+(0.25*F2e-F3e/6.0)*(Wkc1-3.0*Wkc2)*M_ksi));

	ZS[4] = A2P2*(W25i*UJMw*M_ksi+((1.0+1.25*Wkc1+0.25*Wkc2)*S1u-2.0*Wkc4*C1u
			-0.5*M_eta*C2u-E2*S3u/12.0+(1.0-E2*F2e/12.0)*M_eta
			+(Wkc2-3.0*Wkc1)*M_eta*F2e/12.0)+S2*((-1.75-1.125*E2)*S1u+3.25*Wkc4*C1u
			+0.5*M_ksi*S2u+2.0*M_eta*C2u+(7.0/12.0+13.0/48.0*Wkc1+23.0/48.0*Wkc2)*S3u
			+5.0/24.0*Wkc4*C3u+0.375*(M_ksi*S4u-M_eta*C4u)
			+Wkc3*S5u/16.0-Wkc4*C5u/8.0-(1.25-E2*F2e/6.0)*M_eta+(0.25*F2e-F3e/6.0)*(3.0*Wkc1-Wkc2)*M_eta));

	ZS[5] = -CI*ZS[2]+A2P2*(W23i*UJMw+(M_ksi*S1u-M_eta*C1u)+F1e*((1.0-0.25*E2)*(M_ksi*S1u-M_eta*C1u)+0.5*Wkc3*S2u
			-Wkc4*C2u+(Wkc1-3.0*Wkc2)*M_ksi*S3u/12.0+(Wkc2-3.0*Wkc1)*M_eta*C3u/12.0))
			+A2P2*S2*(-(2.0*M_ksi*S1u-M_eta*C1u)+0.75*S2u-(M_ksi*S3u-M_eta*C3u)/6.0+0.5*Wkc4*F2e
			+F1e*((-0.5+1.25*GE2+0.125*Wkc3)*M_ksi*S1u+(2.5+1.25*GE2-0.125*(7.0*Wkc1+5.0*Wkc2))*M_ksi*C1u
			-0.75*Wkc3*S2u+1.5*Wkc4*C2u+(1.0+5.0*GE2/12.0-7.0*Wkc1/48.0+17.0*Wkc2/48.0)*M_ksi*S3u
			-(1.0+5.0*GE2/12.0-19.0*Wkc1/48.0+5.0*Wkc2/48.0)*M_eta*C3u
			+0.375*Wkc3*S4u-0.75*Wkc4*C4u+(Wkc1-3.0*Wkc2)*M_ksi*S5u/16.0
			-(3.0*Wkc1-Wkc2)*M_eta*C5u/16.0-(0.25+(1.0+0.5*E2)*F2e/3.0)*Wkc4));
//--ZS[1]--ZS[5] END----------------------------------------------------
	double A2a = 2.0*A2/M_a;   // 2*A2/a
	double RA4 = RA * RA3;     // (a/r)^4
	double RA5 = RA * RA4;     // (a/r)^5
	double E4 = E2 * E2;       // (1-e^2)^2
	double S4 = S2 * S2;       // sin(i)^4
	double F4e = F1e/GE2;      // F4(e)
	double F5e = 0.5*(5.0+3.0*GE2-2.0*E2)*F1e; // F5(e)
	double Wkc5 = Wkc1 * Wkc1;  // ksi^4
	double Wkc6 = Wkc2 * Wkc2;  // eta^4
	double Wkc7 = Wkc1 * Wkc2;  // ksi^2 * eta^2
	double AS21 = -2.0*(ZS[0]/M_a+A2P2*GE2*W23i)*ZS[0]-A2a*(SI*CI*RA3*(1.0-C2u))*ZS[1]
				-A2a*(RA4/GE2*(M_ksi*S1u-M_eta*C1u)*(1.0-1.5*S2*(1.0-C2u))+GE2*RA5*S2*S2u)*ZS[5]
				+A2a*(RA4*(1.0-1.5*S2*(1.0-C2u))*(C1u+F4e*(Wkc2*C1u-Wkc4*S1u))
				+RA3*S2*S2u*pow(WE2,-1.5)*(-F5e*M_eta-2.0*S1u-0.5*(M_ksi*S2u-M_eta*C2u)+0.5*F1e*M_ksi
				*(4.0*(M_ksi*S1u-M_eta*C1u)+Wkc3*S2u-2.0*Wkc4*C2u)))*ZS[3]
				+A2a*(RA4*(1.0-1.5*S2*(1.0-C2u))*(S1u+F4e*(Wkc1*S1u-Wkc4*C1u))
				+RA3*S2*S2u*pow(WE2,-1.5)*(F5e*M_ksi+2.0*C1u+0.5*(M_ksi*C2u+M_eta*S2u)-0.5*F1e*M_eta
				*(4.0*(M_ksi*S1u-M_eta*C1u)+Wkc3*S2u-2.0*Wkc4*C2u)))*ZS[4];
	double AS22 = A2P2*A2P2*M_a*GE2*(W23i*W23i*((16.0+19.0*E2)/9.0+35.0*E4/(18.0*WE2)+2.0*GE2/9.0)
				+S2*(1.0+2.0*E2/3.0)+S4*(25.0*E2/24.0-5.0/6.0+35.0*E4/(16.0*WE2)
				+(Wkc5-6.0*Wkc7+Wkc6)/(32.0*WE2))+S2*(5.0/6.0-1.75*S2-2.0*W25i*F2e/3.0
				+E2*(7.0/3.0-3.5*S2)/WE2)*Wkc3);
	AS2 = AS21 - AS22;
//--AS2-END-------------------------------------------------------------
	ZS[0] *= Re;
	AS2 *= Re;
}

/*! ƽ
\param inst ˲ʱ
\return ƽ
*/
Kepler Mean(const Kepler & inst)
{
	double ST[6],AS2;
	Kepler ME = inst;
	int count=0;
	double aeps,ksieps,etaeps,ieps,oeps,lmdeps;
	double a2,ksi2,eta2,i2,o2,lamda2;
	double ksi = inst.e*cos(inst.w);
	double eta = inst.e*sin(inst.w);
	double lamda = fmod(inst.w + inst.M,PI2);
	double mksi,meta,mlamda;
	while(true)
	{
		Short2(ME,ST,AS2);
		a2 = ME.a + ST[0] + AS2;
		i2 = ME.i + ST[1];
		o2 = ME.o + ST[2];
		ksi2 = ME.e*cos(ME.w) + ST[3];
		eta2 = ME.e*sin(ME.w) + ST[4];
		lamda2 = ME.w + ME.M + ST[5];		
		aeps = a2 - inst.a;
		ieps = i2 - inst.i;
		oeps = fmod(o2 - inst.o,PI2);
		ksieps = ksi2 - ksi;
		etaeps = eta2 - eta;
		lmdeps = fmod(lamda2 - lamda,PI2);
		if(lmdeps>3.15) lmdeps -= PI2;
		if( fabs(aeps)<1e-6 && fabs(ksieps)<1e-10 && fabs(etaeps)<1e-10
		    && fabs(ieps)<1e-8 && fabs(oeps)<1e-8 && fabs(lmdeps)<1e-8 )
			break;
		if( count++>50 )
		{
			throw KeplerException("Mean(): iteration too many times!");
			break;
		}
		ME.a = inst.a - ST[0] - AS2;
		ME.i = inst.i - ST[1];
		ME.o = inst.o - ST[2];
		mksi = inst.e*cos(inst.w) - ST[3];
		meta = inst.e*sin(inst.w) - ST[4];
		mlamda = inst.w + inst.M - ST[5];
		ME.e = GG345(mksi,meta);
		ME.w = fmod(atan2(meta,mksi)+PI2,PI2);
		ME.M = fmod(mlamda-ME.w+2*PI2,PI2);
	}
	return ME;
}
/*! ʼƽ
\param init ʼ
\param destin Ŀ
\param m1 һ˲ʱʱͷ
\param m2 ڶ˲ʱʱͷ
\param distri ֲϵΪ0.8˫ıĹ볤Ϊܰ볤80%
*/
void InitPlaneJet(const Kepler & init,const Kepler & destin,Maneuver& m1,Maneuver& m2,double distri)
{
	double daa,e,w,dex,dey,v,daa2,de2;
	double dv1,dv2,u1,u2;
	daa = ( destin.a - init.a ) / init.a * distri; // DeltaA/A
	e = init.e;
	w = init.w;
	dex = destin.e*cos(destin.w) - e*cos(w);
	dey = destin.e*sin(destin.w) - e*sin(w);
	v = sqrt(GE/destin.a)*1000;
	daa2 = daa*daa;
	de2 = dex*dex + dey*dey;

	if( daa2 > de2 )
	{
		u1 = 60.0 * RAD;
		dv1 = v/4.0*(daa2-de2)/(daa-dex*cos(u1)-dey*sin(u1));
		dv2 = v/2.0*daa - dv1;
		double cosu2 = v/2.0/dv2*(dex-2.0*dv1/v*cos(u1));
		double sinu2 = v/2.0/dv2*(dey-2.0*dv1/v*sin(u1));
		u2 = fmod(atan2(sinu2,cosu2)+PI2,PI2);
	}
	else if( daa2 < de2 )
	{
		dv1 = v/4.0*(daa+sqrt(de2));
		double cosu1 = dex/sqrt(de2);
		double sinu1 = dey/sqrt(de2);
		u1 = fmod(atan2(sinu1,cosu1)+PI2,PI2);

		dv2 = v/4.0*(daa-sqrt(de2));
		double cosu2 = -dex/sqrt(de2);
		double sinu2 = -dey/sqrt(de2);
		u2 = fmod(atan2(sinu2,cosu2)+PI2,PI2);
	}
	else
	{
		dv1 = v/2.0*daa;
		dv2 = 0;
		double cosu1 = dex/sqrt(de2)*daa/fabs(daa);
		double sinu1 = dey/sqrt(de2)*daa/fabs(daa);
		u1 = fmod(atan2(sinu1,cosu1)+PI2,PI2);
		u2 = 0;
	}

	double f,ra,ce,se,e1,dm1,dm2;
	f = u1 - w;
	ra = (1.0-e*e)/(1.0+e*cos(f));
	ce = ra*cos(f) + e;
	se = ra*sin(f)/sqrt(1-e*e);
	e1 = atan2(se,ce);
	dm1 = fmod(e1-e*sin(e1)+PI2,PI2);

	f = u2-w;
	ra = (1.0-e*e)/(1.0+e*cos(f));
	ce = ra*cos(f)+e;
	se = ra*sin(f)/sqrt(1-e*e);
	e1 = atan2(se,ce);
	dm2 = fmod(e1-e*sin(e1)+PI2,PI2);

	double tmp;
	if( dm2 < dm1 )
	{
		tmp = dv1;
		dv1 = dv2;
		dv2 = tmp;
		tmp = dm1;
		dm1 = dm2;
		dm2 = tmp;
	}
	//The time spot at which the first pulse occurs
	m1.DV.SetValue(dv1,0,0);
	m1.M = dm1;
	////The time spot at which the second pulse occurs
	if(dv2==0)
	{
		return;
	}
	else
	{
		m2.DV.SetValue(dv2,0,0);
		m2.M = dm2;
	}
}  //end of function InitPlaneJet()

/*! ƽ
\param init ʼ
\param destin Ŀ
\param m1 һιǻ˲ʱʱͷ
\param m2 ڶιRAAN˲ʱʱͷ
\param distri ֲϵΪ0.8мĦV80%
*/
void InitNormalJet(const Kepler & init,const Kepler & destin,Maneuver& m1,Maneuver& m2,double distri)
{
	double wn = sqrt(GE/init.a/init.a/init.a);
	double E1 = KeplerFunc(init.e , init.M);

	double idv = -(destin.i - init.i) * (wn*init.a*sqrt(1-init.e*init.e)) / (1-init.e*cos(E1)) * 1000;
	m1.DV.SetValue(0, idv*distri, 0); //Flag=3*int(idv/fabs(idv));
	m1.M = fmod( -init.w + PI2, PI2 );

	idv = -(destin.o - init.o) * (wn*init.a*sqrt(1-init.e*init.e))	* sin(init.i) / (1-init.e*cos(E1)) * 1000;
	m2.DV.SetValue(0, idv*distri, 0); //Flag=3*int(idv/fabs(idv));
	m2.M = fmod( PI/2 - init.w + PI2, PI2 );//f=PI/2-w ==> M
}

/*! relative position and velocity in satellite RefSat orbit coordinate
\param RefSat Ŀ
\param chaser ׷ٹ
\param RelPos chaser's relative position in RefSat's orbit coordination
\param RelVel chaser's relative velocity to satellite in RefSat's orbit coordination
*/
void RIC(const Kepler& chaser,const Kepler& RefSat,Vector& RelPos,Vector& RelVel)
{
	Vector rc,vc,rt,vt;
	Kepler_Cartesian(chaser,rc,vc);
	Kepler_Cartesian(RefSat,rt,vt);
	Matrix Coti = GetCoi(RefSat);
	RelPos = Coti*(rc - rt);
	//Vector w(0,-RefSat.n(),0);
	// ĹٶӦλٶ㣬ʹƽ
	// ȣٶв𣬲СĿƫй
	Vector w = Cross(rt,vt)/rt.Module()/rt.Module();
	w = Coti*w;
	RelVel = Coti*(vc - vt) - Cross(w,RelPos);
}

/*! orbit elements of a satellite which has relative position and relative velocity in satellite RefSat orbit coordinate
\param RefSat reference satellite
\param relpos relative position
\param relvel relative velocity
\return elem chaser orbit elements
*/
Kepler RIC(const Kepler & RefSat,const Vector & relpos,const Vector & relvel)
{
	Matrix Coti = GetCoi(RefSat);
	Vector rt,vt;
	Kepler_Cartesian(RefSat,rt,vt);
	//Vector w(0,-RefSat.n(),0);
	// ĹٶӦλٶ㣬ʹƽ
	// ȣٶв𣬲СĿƫй
	Vector w = Cross(rt,vt)/rt.Module()/rt.Module();
	w = Coti*w;
	Vector cPos = rt + ~Coti*relpos; //Ŀڹϵµλʸ
	Vector cVel = vt + ~Coti*(relvel + Cross(w,relpos)); //Ŀڹϵµٶʸ
	return Cartesian_Kepler(cPos,cVel); //Ŀϵλٶȼ
}

/*! ӹϵתRefSatĹϵ
\param ECI ʸڹϵе
\param RefSat ο
\return ʸVVLHе
*/
const Vector ECI_VVLH(const Vector ECI,const CSatelliteBase & RefSat)
{
	return ECI.RotationZ(RefSat.Omega).RotationX(RefSat.i).RotationZ(RefSat.u+PI/2.0).RotationX(-PI/2.0);
}
/*! RefSatĹϵתϵ
\param VVLH ʸڹϵе
\param RefSatο
\return ʸECIе
*/
const Vector VVLH_ECI(const Vector VVLH,const CSatelliteBase & RefSat)
{
	return VVLH.RotationX(PI/2.0).RotationZ(-RefSat.u-PI/2.0).RotationX(-RefSat.i).RotationZ(-RefSat.Omega);
}
/*! ɵعϵλüγȺ͸߶
\param ECF عϵλ,λkm
\return γȺ͸߶(deg,km)
*/
const CSpherical ECF_LLA(const Vector & ECF)
{
	CSpherical lla; // γ
	lla.Longitude = fmod(atan2(ECF.y,ECF.x) + 4*PI, PI2) * DEG;
	//if( lla.Longitude > 180 ) lla.Longitude -= 360.0;

	double r = ECF.Module();
	double ee = 1.0 - (1.0 - Oblate)*(1.0 - Oblate);
	double b = Re*sqrt(1.0 - ee);
	double x2y2 = sqrt(ECF.x*ECF.x + ECF.y*ECF.y);

	// ʹõγȺ͸߶
	double N = Re;
	double h = r - sqrt(Re*b);
	double B = atan( ECF.z / x2y2 / (1.0 - ee*N/(N+h) ) );
	double N1,h1,B1;
	for(int I=0;I<6;I++)
	{
		N1 = Re/sqrt( 1.0 - ee*sin(B)*sin(B) );
		h1 = x2y2 / cos(B) - N1;
		B1 = atan( ECF.z / x2y2 / (1.0 - ee*N1/(N1+h1)) );
		if( fabs(B1-B)<1e-6 && fabs(h1-h)<1e5 ) break;
		N = N1;
		h = h1;
		B = B1;
	}
	lla.Latitude = B1 * DEG;
	lla.Altitude = h1;

	// ʹOzone㷨γȺ͸߶()
	//double c = Re * sqrt(ee);
	//double n = (Re*x2y2 - c*c) / (2.0*b*ECF.z);
	//double s = (Re*x2y2 + c*c) / (2.0*b*ECF.z);
	//double V = (4.0*n*s + 1.0) / 3.0;
	//double W = (s + n) / (s - n);
	//double D = sqrt(W*W + V*V);
	//double I = pow(D+W,1.0/3.0) - pow(D-W,1.0/3.0);
	//double J = sqrt(4.0*n*n + 2.0*I);
	//double K = sqrt(I*I + 1.0);
	//double T = 2.0*n + J;
	//double G = T*T - 4.0*(I-K);
	//double U = (sqrt(G) + T) / 2.0;
	//double phi = atan( 2.0 * Re * U / b / (U*U-1.0) );
	//lla.Latitude = sign(ECF.z)*phi;
	//lla.Altitude = x2y2/cos(lla.Latitude) - Re/sqrt(1.0 - ee*sin(lla.Latitude)*sin(lla.Latitude));
	//lla.Latitude *= DEG;

	return lla;
}

/*! ̫Ĺϵƽ
\param t CDateTimeʱ
\return ̫ڳϵĹƽ(km,RAD)
*/
const Kepler SunOrbit(const CDateTime& t)
{
	double T = t.GetTDTCentNum();     //tJ2000.0
	double T2 = T * T;
	return Kepler(
		1.00000102*AU,								             		// a
		0.01670862 -            0.00004204*T -     0.00000124*T2,		// e
		Ecliptic_Equator_Angle(t),	// i(epsilon)
		0,
		Sun_Argument_Perigee(t),	
		Sun_Mean_Anomaly(t));
}

/*! ̫ĳϵλʸ
ʹý
\param t CDateimeʱ
\return ̫ڵϵλʸ(km)
*/
const Vector SunAnalytic(const CDateTime& t)//̫
{
	Kepler k = SunOrbit(t);
	Vector r,v;
	Kepler_Cartesian(k,r,v);
	return r;
}

/*! ĵĹϵλʸ
ʹý
\param t  CDatetimeʱ
\return ڵϵλʸ
*/
const Vector MoonAnalytic(const CDateTime& t)
{
	double T = t.GetTDTCentNum();
	double T2 = T*T;
	double T3 = T2*T;
	double T4 = T3*T;
	double l = 134.96340251 + (1717915923.2178*T + 31.8792*T2 + 0.051635*T3 - 0.00024470*T4)/3600;
	//double l = 134.9634 + (1717915923.2178*T)/3600;
	l = l*RAD;

	double lp = 357.52910918 + (129596581.0481*T - 0.5532*T2 - 0.000136*T3 - 0.00001149*T4)/3600;
	//double lp = 357.5291 + (129596581.0481*T)/3600;
	lp = lp*RAD;

	double F = 93.27209062 + (1739527262.8478*T - 12.7512*T2 - 0.00103*T3 + 0.00000417*T4)/3600;
	//double F = 93.272 + (1739527262.8478*T)/3600;
	F = F*RAD;
	
	double D = 297.85019547 + (1602961601.2090*T - 6.3706*T2 + 0.006593*T3 - 0.00003169*T4)/3600;
	//double D = 297.85 + (1602961601.2090*T)/3600;
	D = D*RAD;
	
	double Omega = 125.04455501 + (-6962890.2665*T + 7.47222*T2 + 0.007702*T3 - 0.00005939*T4)/3600;
	//double Omega = 125.044555 + (-6962890.2665*T)/3600;
	Omega = Omega*RAD;
	
	double dF = 22640*sin(l) + 769*sin(2*l) + 36*sin(3*l) - 125*sin(D) + 2370*sin(2*D) 
	    -668*sin(lp) - 412*sin(2*F) + 212*sin(2*D-2*l) + 4586*sin(2*D-l) + 192*sin(2*D+l) 
	    +165*sin(2*D-lp) + 206*sin(2*D-l-lp) - 110*sin(l+lp) + 148*sin(l-lp);
	//double dF = 22640*sin(l) + 2370*sin(2*D) + 4586*sin(2*D-l);
	dF = dF/3600*RAD;
	
	F = F + dF;
	F = fmod(F,PI*2);
	if (F>PI)
	    F = F-PI2;
	
	double em = 0.05490;
	double am = 384401;
	double im = 5.145396*RAD;
	
	double E = KeplerFunc(em,l);
	//double E = l + em*sin(l);// + 1/2*em^2*sin(2*l);
	double u;
	if (F>=-PI/2 && F<=PI/2)
	    u = atan(tan(F)/cos(im));
	else if (F<-PI/2)
	    u = atan(tan(F)/cos(im)) - PI;
	else // F>PI/2
	    u = atan(tan(F)/cos(im)) + PI;
	    
	double f = atan2(am*sqrt(1-em*em)*sin(E),am*cos(E)-am*em);
	double w = u - f;
	double r = am*(1-em*em)/(1+em*cos(f));
	//double epson = (84381.448 - 46.815*T - 0.00059*T^2 + 0.001813*T^3)/3600*rad;
	double epson = 0.409105;
	return r*RotationX(-epson)*RotationZ(-Omega)*RotationX(-im)*Vector(cos(u),sin(u),0);
}

/*! Ĺϵ(J2000.0ϵ)Ĺϵת
\param r Ĺϵʸ
\param TDT Լձʾĵѧʱ(Unit:day)
\return Ĺϵʸ
*/
const Vector ECI_MCI(const CDateTime& t,Vector & r)
{
	return r - DE405::Instance()->Moon(t);
}

/*! ĹϵλٶȼĹϵ2еĹ\n
ĹϵָĹϵ(J2000.0)ƽƵĵϵ\n
Ĺϵ2ָΪXYƽ棬XָJ2000.0ֵϵͶӰ
\param TDT Լձʾĵѧʱ(Unit:day)
*/
const Kepler MCI_MCI2Kepler(const CDateTime& t,Vector& r,Vector& v)
{
	double T = t.GetTDTCentNum(); //TDTJ2000.0
	double T2 = T*T;
	double epson = (23.439291 -    46.8150/3600.0*T - 0.00059/3600.0*T2 ) * RAD;  // Ƴཻ
	double OMEGA = ( 125.0445555 - 1934.136185*T +  7.476/3600.0*T2 ) * RAD;  // ׵ƽƾ(Ӧƽֵ)
	double I = 0.0267617152;  // Ƶļн
	double Op = atan2(sin(OMEGA)*cos(I),cos(OMEGA));
	Vector Pos = r.RotationX(epson).RotationZ(OMEGA).RotationX(-I).RotationZ(-Op);
	Vector Vel = v.RotationX(epson).RotationZ(OMEGA).RotationX(-I).RotationZ(-Op);
	return Cartesian_Kepler(Pos,Vel,GM);
}
/*! Ĺϵ(J2000.0ϵ)Ĺϵת
\param r Ĺϵλ
\param v Ĺϵٶ
\param t CDateTimeʱ
\param rm Ĺϵλ
\param vm Ĺϵٶ
*/
void ECI_MCI(const CDateTime& t,Vector & r,Vector& v,Vector & rm,Vector& vm)
{
	Vector MPos,MVel;
	DE405::Instance()->PlanetEphemeris(t,EARTH,MOON,MPos,MVel);
    rm = r - MPos;
	vm = v - MVel;
}
/*! MCIMCFת
is the matrix of coordinate transformation
for moon-fixed coordinate system
to moon-inteial coordinate system   \n

MCFr = MCI_MCF*MCIr;   MCIr = ~MCI_MCF*MCFr;
\param t CDateTimeʱ
*/
Matrix MCI_MCF(const CDateTime& t)
{
	double Omega,i,u;
	DE405::Instance()->Librations(t,Omega,i,u);
	return RotationZ(u)*RotationX(i)*RotationZ(Omega);
}
/*! ECIECFת
	(HG) = (EP)(ER)(NR)(PR)   \n
		is the matrix of coordinate transformation
		for earth-fixed coordinate system
		to celestial coordinate system of epoch   \n
	(-HG) is transpose of matrix (HG)

	ECFr = ECI_ECF*ECIr;   ECIr = ~ECI_ECF*ECFr;
\param t CDateTimeʱ
\param PolarDriftX 
\param PolarDriftY 
*/
Matrix ECI_ECF(const CDateTime& t)
{
	return PolarMotion(t) * EarthRotation(t) * Nutation(t) * Precession(t);
}

/*! precession matrix
  һʸJ2000.0ϵµΪr˲ʱƽϵеΪ Precession*r
  ֮һʸ˲ʱƽϵµΪrJ2000.0ϵеΪ ~Precession*r
  u1,u2,u3תΪPrecession = Rz(-Z)*Ry(theta)*Rz(-zeta)
\param t CDateTimeʱ
\return תPR
\[
\left( {PR} \right) = R_z \left( { - z_A } \right)R_y \left( {\theta _A } \right)R_z \left( { - \zeta _A } \right)
\]
*/
Matrix Precession(const CDateTime& t)
{
	double zeta,theta,Z;
	precession_angle(t,zeta,theta,Z);
	return RotationZ(-Z)*RotationY(theta)*RotationZ(-zeta);
}
/*! ϵ
- (zeta+Z): ྭ
- theta: γ
\param  t  ʱ
\param  zeta precession angle ( unit: radian )
\param  theta precession angle ( unit: radian )
\param  Z precession angle ( unit: radian )
\[
\begin{array}{l}
 \zeta _A  = 2306''.2181t + 0''.30188t^2  + 0''.017998t^3  \\ 
 z_A  = 2306''.2181t + 1''.09468t^2  + 0''.018203t^3  \\ 
 \theta _A  = 2004''.3109t - 0''.42665t^2  - 0''.041833t^3  \\ 
 \end{array}
\]

*/
void precession_angle(const CDateTime& t,double& zeta,double& theta,double& Z)
{
	double dt = t.GetTDTCentNum();
	// 206264.806247096 = 3600*DEG
	zeta  = dt*(2306.2181 + dt*(0.30188 + 0.017998*dt) )/206264.806247096;
	theta = dt*(2004.3109 - dt*(0.42665 - 0.041833*dt) )/206264.806247096;
	Z     = dt*(2306.2181 + dt*(1.09468 + 0.018203*dt) )/206264.806247096;
}
/*! ¶ nutation matrix
  һʸ˲ʱƽϵµΪr˲ʱϵеΪ Nutation*r
  ֮һʸ˲ʱϵµΪr˲ʱƽϵеΪ ~Nutation*r
  ¶u1,u2,u3תΪNutation = Rz(-(eps+deps))*Ry(-dksi)*Rx(eps)
\param t CDatetimeʱ
\return ¶NU
*/
Matrix Nutation(const CDateTime& t)
{
	double dksi,deps;
	double eps = Ecliptic_Equator_Angle(t);
	nutation_angle(t,dksi,deps);
	return RotationX(-eps-deps)*RotationZ(-dksi)*RotationX(eps);
}
/*!¶ϵ
- dksi: ƾ¶
- deps: ¶
\param t CDatetimeʱ
\param dksi ƾ¶ ( unit: radian )
\param deps ¶ ( unit: radian )
*/
void nutation_angle(const CDateTime& t,double& dksi,double& deps)
{
	/*
	//֡ۡеķ¶ǣ
	//JPL DE405Ƚϣ¶ǵĲС0.3"
	//static const double A0[5] = {-17.1996,-1.3187, -0.2274, 0.2026,  0.1426  };
	//static const double A1[5] = {-0.01742,-0.00016,-0.00002,0.00002,-0.00034 };
	//static const double B0[5] = {   9.2025,   0.5736,   0.0977, -0.0859,   0.0054 };
	//static const double B1[5] = {  0.00089, -0.00031, -0.00005, 0.00005, -0.00001 };
	// 泣ĵλɽתΪ:
	static const double A0[5] = {-8.33860138961158e-005, -6.39323801279145e-006, -1.10246631084308e-006, 9.8223251792792e-007, 6.91344309262198e-007 };
	static const double A1[5] = {-8.44545432492812e-008, -7.75701889775258e-010, -9.69627362219072e-011, 9.69627362219072e-011, -1.64836651577242e-009 };
	static const double B0[5] = {4.4614979004105e-005,  2.7808912748443e-006,  4.73662966444017e-007,  -4.16454952073091e-007,  2.61799387799149e-008 };
	static const double B1[5] = {4.31484176187487e-009, -1.50292241143956e-009,  -2.42406840554768e-010,  2.42406840554768e-010, -4.84813681109536e-011 };
	double alfa[5],beta[5];
	double dt = t.GetTDTCentNum();
	alfa[0] = (1325*360.0 + 198.86739806)*dt;
	alfa[1] = (  99*360.0 + 359.05034000)*dt;
	alfa[2] = (1342*360.0 + 82.01753806 )*dt;
	alfa[3] = (1236*360.0 + 307.11148000)*dt;
	alfa[4] =-(   5*360.0 + 134.13626083)*dt;
	int i;
	for(i=0;i<5;i++)    alfa[i] = fmod(alfa[i]+3600,360);
	alfa[0] = (alfa[0] + 134.96298139 + 0.00869722*dt*dt)*RAD;
	alfa[1] = (alfa[1] + 357.52772333 - 0.00016028*dt*dt)*RAD;
	alfa[2] = (alfa[2] + 93.271910280 - 0.00368250*dt*dt)*RAD;
	alfa[3] = (alfa[3] + 297.85036306 - 0.00191417*dt*dt)*RAD;
	alfa[4] = (alfa[4] + 125.04452222 + 0.00207083*dt*dt)*RAD;
	beta[0] = alfa[4];
	beta[1] = 2.0*(alfa[2] - alfa[3] + alfa[4]);
	beta[2] = 2.0*(alfa[2] + alfa[4]);
	beta[3] = 2.0*alfa[4];
	beta[4] = alfa[1];
	dksi = 0.0;
	deps = 0.0;
	for(i=0;i<5;i++)
	{
		dksi += (A0[i]+A1[i]*dt)*sin(beta[i]);
		deps += (B0[i]+B1[i]*dt)*cos(beta[i]);
	}*/
	

	/* IAU 1980 Theory of Nutation */

	const double rev = 360.0*3600.0;  // arcsec/revolution
        
	const int  N_coeff = 106;
	const long C[106][9] = {
        {  0, 0, 0, 0, 1,-1719960,-1742,  920250,   89 },   //   1
        {  0, 0, 0, 0, 2,   20620,    2,   -8950,    5 },   //   2
        { -2, 0, 2, 0, 1,     460,    0,    -240,    0 },   //   3
        {  2, 0,-2, 0, 0,     110,    0,       0,    0 },   //   4
        { -2, 0, 2, 0, 2,     -30,    0,      10,    0 },   //   5
        {  1,-1, 0,-1, 0,     -30,    0,       0,    0 },   //   6
        {  0,-2, 2,-2, 1,     -20,    0,      10,    0 },   //   7
        {  2, 0,-2, 0, 1,      10,    0,       0,    0 },   //   8
        {  0, 0, 2,-2, 2, -131870,  -16,   57360,  -31 },   //   9
        {  0, 1, 0, 0, 0,   14260,  -34,     540,   -1 },   //  10
        {  0, 1, 2,-2, 2,   -5170,   12,    2240,   -6 },   //  11
        {  0,-1, 2,-2, 2,    2170,   -5,    -950,    3 },   //  12
        {  0, 0, 2,-2, 1,    1290,    1,    -700,    0 },   //  13
        {  2, 0, 0,-2, 0,     480,    0,      10,    0 },   //  14
        {  0, 0, 2,-2, 0,    -220,    0,       0,    0 },   //  15
        {  0, 2, 0, 0, 0,     170,   -1,       0,    0 },   //  16
        {  0, 1, 0, 0, 1,    -150,    0,      90,    0 },   //  17
        {  0, 2, 2,-2, 2,    -160,    1,      70,    0 },   //  18
        {  0,-1, 0, 0, 1,    -120,    0,      60,    0 },   //  19
        { -2, 0, 0, 2, 1,     -60,    0,      30,    0 },   //  20
        {  0,-1, 2,-2, 1,     -50,    0,      30,    0 },   //  21
        {  2, 0, 0,-2, 1,      40,    0,     -20,    0 },   //  22
        {  0, 1, 2,-2, 1,      40,    0,     -20,    0 },   //  23
        {  1, 0, 0,-1, 0,     -40,    0,       0,    0 },   //  24
        {  2, 1, 0,-2, 0,      10,    0,       0,    0 },   //  25
        {  0, 0,-2, 2, 1,      10,    0,       0,    0 },   //  26
        {  0, 1,-2, 2, 0,     -10,    0,       0,    0 },   //  27
        {  0, 1, 0, 0, 2,      10,    0,       0,    0 },   //  28
        { -1, 0, 0, 1, 1,      10,    0,       0,    0 },   //  29
        {  0, 1, 2,-2, 0,     -10,    0,       0,    0 },   //  30
        {  0, 0, 2, 0, 2,  -22740,   -2,    9770,   -5 },   //  31
        {  1, 0, 0, 0, 0,    7120,    1,     -70,    0 },   //  32
        {  0, 0, 2, 0, 1,   -3860,   -4,    2000,    0 },   //  33
        {  1, 0, 2, 0, 2,   -3010,    0,    1290,   -1 },   //  34
        {  1, 0, 0,-2, 0,   -1580,    0,     -10,    0 },   //  35
        { -1, 0, 2, 0, 2,    1230,    0,    -530,    0 },   //  36
        {  0, 0, 0, 2, 0,     630,    0,     -20,    0 },   //  37
        {  1, 0, 0, 0, 1,     630,    1,    -330,    0 },   //  38
        { -1, 0, 0, 0, 1,    -580,   -1,     320,    0 },   //  39
        { -1, 0, 2, 2, 2,    -590,    0,     260,    0 },   //  40
        {  1, 0, 2, 0, 1,    -510,    0,     270,    0 },   //  41
        {  0, 0, 2, 2, 2,    -380,    0,     160,    0 },   //  42
        {  2, 0, 0, 0, 0,     290,    0,     -10,    0 },   //  43
        {  1, 0, 2,-2, 2,     290,    0,    -120,    0 },   //  44
        {  2, 0, 2, 0, 2,    -310,    0,     130,    0 },   //  45
        {  0, 0, 2, 0, 0,     260,    0,     -10,    0 },   //  46
        { -1, 0, 2, 0, 1,     210,    0,    -100,    0 },   //  47
        { -1, 0, 0, 2, 1,     160,    0,     -80,    0 },   //  48
        {  1, 0, 0,-2, 1,    -130,    0,      70,    0 },   //  49
        { -1, 0, 2, 2, 1,    -100,    0,      50,    0 },   //  50
        {  1, 1, 0,-2, 0,     -70,    0,       0,    0 },   //  51
        {  0, 1, 2, 0, 2,      70,    0,     -30,    0 },   //  52
        {  0,-1, 2, 0, 2,     -70,    0,      30,    0 },   //  53
        {  1, 0, 2, 2, 2,     -80,    0,      30,    0 },   //  54
        {  1, 0, 0, 2, 0,      60,    0,       0,    0 },   //  55
        {  2, 0, 2,-2, 2,      60,    0,     -30,    0 },   //  56
        {  0, 0, 0, 2, 1,     -60,    0,      30,    0 },   //  57
        {  0, 0, 2, 2, 1,     -70,    0,      30,    0 },   //  58
        {  1, 0, 2,-2, 1,      60,    0,     -30,    0 },   //  59
        {  0, 0, 0,-2, 1,     -50,    0,      30,    0 },   //  60
        {  1,-1, 0, 0, 0,      50,    0,       0,    0 },   //  61
        {  2, 0, 2, 0, 1,     -50,    0,      30,    0 },   //  62
        {  0, 1, 0,-2, 0,     -40,    0,       0,    0 },   //  63
        {  1, 0,-2, 0, 0,      40,    0,       0,    0 },   //  64
        {  0, 0, 0, 1, 0,     -40,    0,       0,    0 },   //  65
        {  1, 1, 0, 0, 0,     -30,    0,       0,    0 },   //  66
        {  1, 0, 2, 0, 0,      30,    0,       0,    0 },   //  67
        {  1,-1, 2, 0, 2,     -30,    0,      10,    0 },   //  68
        { -1,-1, 2, 2, 2,     -30,    0,      10,    0 },   //  69
        { -2, 0, 0, 0, 1,     -20,    0,      10,    0 },   //  70
        {  3, 0, 2, 0, 2,     -30,    0,      10,    0 },   //  71
        {  0,-1, 2, 2, 2,     -30,    0,      10,    0 },   //  72
        {  1, 1, 2, 0, 2,      20,    0,     -10,    0 },   //  73
        { -1, 0, 2,-2, 1,     -20,    0,      10,    0 },   //  74
        {  2, 0, 0, 0, 1,      20,    0,     -10,    0 },   //  75
        {  1, 0, 0, 0, 2,     -20,    0,      10,    0 },   //  76
        {  3, 0, 0, 0, 0,      20,    0,       0,    0 },   //  77
        {  0, 0, 2, 1, 2,      20,    0,     -10,    0 },   //  78
        { -1, 0, 0, 0, 2,      10,    0,     -10,    0 },   //  79
        {  1, 0, 0,-4, 0,     -10,    0,       0,    0 },   //  80
        { -2, 0, 2, 2, 2,      10,    0,     -10,    0 },   //  81
        { -1, 0, 2, 4, 2,     -20,    0,      10,    0 },   //  82
        {  2, 0, 0,-4, 0,     -10,    0,       0,    0 },   //  83
        {  1, 1, 2,-2, 2,      10,    0,     -10,    0 },   //  84
        {  1, 0, 2, 2, 1,     -10,    0,      10,    0 },   //  85
        { -2, 0, 2, 4, 2,     -10,    0,      10,    0 },   //  86
        { -1, 0, 4, 0, 2,      10,    0,       0,    0 },   //  87
        {  1,-1, 0,-2, 0,      10,    0,       0,    0 },   //  88
        {  2, 0, 2,-2, 1,      10,    0,     -10,    0 },   //  89
        {  2, 0, 2, 2, 2,     -10,    0,       0,    0 },   //  90
        {  1, 0, 0, 2, 1,     -10,    0,       0,    0 },   //  91
        {  0, 0, 4,-2, 2,      10,    0,       0,    0 },   //  92
        {  3, 0, 2,-2, 2,      10,    0,       0,    0 },   //  93
        {  1, 0, 2,-2, 0,     -10,    0,       0,    0 },   //  94
        {  0, 1, 2, 0, 1,      10,    0,       0,    0 },   //  95
        { -1,-1, 0, 2, 1,      10,    0,       0,    0 },   //  96
        {  0, 0,-2, 0, 1,     -10,    0,       0,    0 },   //  97
        {  0, 0, 2,-1, 2,     -10,    0,       0,    0 },   //  98
        {  0, 1, 0, 2, 0,     -10,    0,       0,    0 },   //  99
        {  1, 0,-2,-2, 0,     -10,    0,       0,    0 },   // 100
        {  0,-1, 2, 0, 1,     -10,    0,       0,    0 },   // 101
        {  1, 1, 0,-2, 1,     -10,    0,       0,    0 },   // 102
        {  1, 0,-2, 2, 0,     -10,    0,       0,    0 },   // 103
        {  2, 0, 0, 2, 0,      10,    0,       0,    0 },   // 104
        {  0, 0, 2, 4, 2,     -10,    0,       0,    0 },   // 105
        {  0, 1, 0, 1, 0,      10,    0,       0,    0 }    // 106
    };
        
    // Variables
    double  l, lp, F, D, Om; //Om changed to class variable
    double  arg;
    double T = t.GetTDTCentNum();
	double T2 = T*T;
	double T3 = T2*T;
    // Mean arguments of luni-solar motion
    //   l   mean anomaly of the Moon
    //   l'  mean anomaly of the Sun
    //   F   mean argument of latitude
    //   D   mean longitude elongation of the Moon from the Sun
    //   Om  mean longitude of the ascending node
    // IERS tech report 21 1996 conventions (below)
	l  = fmod( 134.96340251*3600 + 1717915923.2178*T  + 31.8792*T2 + 0.051635*T3, rev );
	lp = fmod( 357.52910918*3600 + 129596581.0481*T  -  0.5532*T2 - 0.000136*T3, rev );
	F  = fmod( 93.27209062*3600 + 1739527262.8478*T  - 12.7512*T2 - 0.001037*T3, rev );
	D  = fmod( 297.85019547*3600 + 1602961601.2090*T  -  6.3706*T2 + 0.006593*T3, rev );
    Om = fmod( 450160.398036 - 6962890.2665*T + 7.4722*T2 + 0.007702*T3 - 0.00005939*T3*T, rev );
// JAT,IERSԱȣ¶ǼĲ2*10^-5
//    l  = fmod(  485866.733 + (1325.0*rev +  715922.633)*T + 31.310*T2 + 0.064*T3, rev );
//    lp = fmod( 1287099.804 + (  99.0*rev + 1292581.224)*T -  0.577*T2 - 0.012*T3, rev );
//    F  = fmod(  335778.877 + (1342.0*rev +  295263.137)*T - 13.257*T2 + 0.011*T3, rev );
//    D  = fmod( 1072261.307 + (1236.0*rev + 1105601.328)*T -  6.891*T2 + 0.019*T3, rev );
//    Om = MathUtils.Modulo(  450160.280 - (   5.0*rev +  482890.539)*T +  7.455*T2 + 0.008*T3, rev );
       
    // Nutation in longitude and obliquity [rad]
    const double Arcs = RAD/3600.0;
        
	deps = 0.0;
	dksi = 0.0;
	for (int i=0; i<N_coeff; i++) {
		arg  =  ( C[i][0]*l + C[i][1]*lp + C[i][2]*F + C[i][3]*D + C[i][4]*Om ) * Arcs;
		dksi += ( C[i][5]+C[i][6]*T ) * sin(arg);
		deps += ( C[i][7]+C[i][8]*T ) * cos(arg);
	}
// TODO
//* Delta Delta corrections
//        double ddpsi = -0.0534;
//        double ddeps = -0.00472;
//        this.dpsi = this.dpsi + ddpsi;
//        this.deps = this.deps + ddeps;
        
	dksi = 1.0E-5 * dksi*Arcs;
	deps = 1.0E-5 * deps*Arcs;
}
/*! תearth rotatioin matrix
  һʸ˲ʱϵµΪr׼عϵеΪ EarthRotation*r
  ֮һʸ׼عϵµΪr˲ʱϵеΪ ~EarthRotation*r
  κʱSG     תΪEarthRotation = Rz(SG)
\param t CDatetimeʱ
\return ת
*/
Matrix EarthRotation(const CDateTime& t)
{
	return RotationZ( GetSG(t) );
}
/*!  ƾ
[1,   0,   Xp]
[0,   1,  -Yp]
[Xp,  Yp,   1]
һʸ׼عϵµΪrڵعϵеΪ PolarMotion*r
֮һʸڵعϵµΪr׼عϵеΪ ~PolarMotion*r
*/
Matrix PolarMotion(const CDateTime& t)
{
	double Xp,Yp;
	Earth::Instance()->GetPolarMotion(t,Xp,Yp);
	Matrix m(3,3);
	m.Unit();
	m(0,2) = Xp;
	m(2,0) = -Xp;
	m(1,2) = -Yp;
	m(2,1) = Yp;
	return m;
}
/*!ǹϵԹϵķ
      [ 0  1   0]
Coi = [ 0  0  -1]*RotationZ(u)*RotationX(i)*RotationZ(Omega)
      [-1  0   0]
\param sat 
\return ǹϵԹϵķ
*/
Matrix GetCoi(const Kepler& k)
{
	Matrix T(3,3);
	T(0,1) = 1.0;    T(1,2) = -1.0;    T(2,0) = -1.0;
	Matrix C = RotationZ(k.u())*RotationX(k.i)*RotationZ(k.o);
	return T*C;
}
/*!ʸx,y,zһ
    [x.x  x.y  x.z]
M = [y.x  y.y  y.z]
    [z.x  z.y  z.z]
\param x Xʸ
\param y Yʸ
\param z Zʸ
\return ɵľ
*/
Matrix Vector2Matrix(const Vector& x,const Vector& y,const Vector& z)
{
	Matrix m(3,3);
	m(0,0) = x.x;	m(0,1) = x.y;	m(0,2) = x.z;
	m(1,0) = y.x;	m(1,1) = y.y;	m(1,2) = y.z;
	m(2,0) = z.x; 	m(2,1) = z.y; 	m(2,2) = z.z; 
	return m;
}
/*!ɾȡʸʸֱΪĵ1~3
\param m 
\param x Xʸ
\param y Yʸ
\param z Zʸ
*/
void Matrix2Vector(const Matrix& m,Vector& x,Vector& y,Vector& z)
{
	x.x = m(0,0);	x.y = m(0,1);	x.z = m(0,2);
	y.x = m(1,0);	y.y = m(1,1);	y.z = m(1,2);
	z.x = m(2,0);	z.y = m(2,1);	z.z = m(2,2);
}

#if _MSC_VER < 1400
void fopen_s(FILE** fp,const char* filename,const char* rw)
{
	*fp = fopen(filename,rw);
}
#endif // _MSC_VER < 1400
